# A function to return a calculated heat of adsoroption (delta-Q) based on multi-isotherm 
#data via the clausius clapeyron relation. requires data from BELSORP-HP in an HPD format
from gas_sorp_treat import *
import numpy as np
from scipy import optimize
import matplotlib.pyplot as plt

import time, os, math

folder = os.getcwd()#'C:\\Users\\kcj\\Desktop\\Papers\\YCan_paper_data\\gsorp2'

R = -8.31447
virial_cache = open(folder + '\\virial_cache.csv', 'a+')

def virial_solve(*idents, **kwargs):
	temps, mmolss, lnpe2s = [],[],[]
	pn = int(kwargs['pn'])
	p0 = [0]*pn
	for ident_num in idents:
		de = desorption_split(ident_num)-1
		mlperg = returndata(ident_num, 11)[2:de]
		mmols  = [float(i)/22.414 for i in mlperg]
		pe2    = returndata(ident_num, 4)[2:de]
		lnpe2  = [np.log(float(i)) for i in pe2]
		temp   = float(temp_get(ident_num)[:-1])
		for i in range(len(mmols)):
			mmolss.append(mmols[i])
			lnpe2s.append(lnpe2[i])
			temps.append(temp)
	temps  = np.array(temps)
	mmolss = np.array(mmolss)
	lnpe2s = np.array(lnpe2s)
	
	
	#for i in range(len(mmolss)):
	#	print str(mmolss[i]) +' '+ str(lnpe2s[i]) +' '+ str(temps[i])
	virial_func = lambda p, x, temp: np.log(x) + sum([i*x**j for j,i in enumerate(p[:-1])])/temp + p[-1] #x is mmols
	error_func  = lambda p, x, y, temp: (virial_func(p, x, temp) - y)**2
	q_func = lambda p, x: R * sum([i*x**j for j,i in enumerate(p[:-1])])/1000

	p1, success = optimize.leastsq(error_func, p0[:], args=(mmolss, lnpe2s,temps))
	# print sum(error_func(p1,mmolss, lnpe2s,temps)) #p1,
	
	rss = sum(error_func(p1,mmolss, lnpe2s,temps))
	tss = sum([(i-np.mean(lnpe2s))**2 for i in lnpe2s])
	rsq = 1-(rss/tss)
	print rsq
	
	virial_cache.write(idents[0]+','+ max(q_func(p1, mmolss)).astype('str')+','+','.join([str(i)for i in p1.tolist()])+',' +rsq.astype('str') + '\n')
	plt.plot(mmolss, lnpe2s, 'rx')
	plt.plot(mmolss, virial_func(p1, mmolss, temps), 'bo')
	plt.show()
	fig = plt.figure()
	ax = fig.add_subplot(111)
		
	ax.plot(mmolss, q_func(p1, mmolss), 'bD')
	plt.ylim(ymin = 0, ymax = (math.ceil(max(q_func(p1, mmolss))+1)/5)*5)
	
	ax.set_xlabel('sorbed gas mmol/g')
	ax.set_ylabel('Q (kJ/mol)')
	ax.set_title(idents[0]+ '\n')
	
	fig.savefig(folder +'\\'+ str(time.time()) +".png", transparent = True, dpi = 1000)
	#plt.show()

#virial_solve('20170323ed','20170324ed', '20170326ed', pn = 4)
virial_solve('20170331ed','20170403ed', '20170404ed', pn = 4)

virial_cache.close()